import { ParameterOptions, OptionOptions } from './types';
import { IDebugger } from 'debug';
export declare enum PathTokenType {
    route = "route",
    param = "param",
    optional = "optional"
}
export interface PathToken {
    name: string;
    type: PathTokenType;
}
export interface EvalResult {
    match: boolean;
    params: {
        [name: string]: any;
    };
    options: {
        [name: string]: any;
    };
}
export declare class Path<TContext = any> {
    protected log: IDebugger;
    protected _name: string;
    readonly name: string;
    protected _params: {
        [name: string]: ParameterOptions;
    };
    readonly params: Readonly<{
        [name: string]: ParameterOptions;
    }>;
    readonly options: Readonly<{
        [name: string]: OptionOptions;
    }>;
    protected _options: {
        [name: string]: OptionOptions;
    };
    info?: any;
    constructor(name: string);
    param(name: string, options?: ParameterOptions): void;
    option(name: string, options?: OptionOptions): void;
    protected tokenizePath(path: string): PathToken[];
    protected evalPath(inputArgs: string[], pathTokens: PathToken[]): EvalResult;
    private evalPathToken;
    private validateParam;
    private processOptions;
    private extractOptions;
}
//# sourceMappingURL=Path.d.ts.map