import { CommandHandler, CommandInput, CommandOutput, ParameterOptions, OptionOptions } from './types';
import { Command } from './Command';
import { Path } from './Path';
interface RouteModule {
    route: Route;
}
export interface LazyLoader {
    (): Promise<RouteModule>;
}
export declare class Route<TContext = any> extends Path {
    private _parent?;
    private _routes;
    private _commands;
    readonly parent: Readonly<Route<any>> | undefined;
    readonly commands: ReadonlyArray<{
        name: string;
        params: {
            [name: string]: ParameterOptions;
        };
        options: {
            [name: string]: OptionOptions;
        };
        info?: any;
    }>;
    readonly routes: Promise<ReadonlyArray<Route<any> | undefined>>;
    private _default?;
    private useHandlers;
    constructor(name: string);
    use(...handler: CommandHandler<TContext>[]): Route;
    command(path: string, ...handler: CommandHandler<TContext>[]): Command;
    default(...handler: CommandHandler<TContext>[]): Command;
    route(path: string, route?: Route): Route;
    lazyRoute(path: string, loader: LazyLoader): void;
    lazyRoute(path: string, requirePath: string): void;
    protected _run(parent: Route | undefined, pathAndParams: string[], input: CommandInput, output: CommandOutput, next: () => void): void;
    protected processCommands(pathAndParams: string[], input: CommandInput, output: CommandOutput, originalInputParams: {
        [name: string]: any;
    }, next: () => void): void;
    protected processRoutes(pathAndParams: string[], input: CommandInput, output: CommandOutput, originalInputParams: {
        [name: string]: any;
    }, next: () => void): void;
    protected processDefault(pathAndParams: string[], input: CommandInput, output: CommandOutput, originalInputParams: {
        [name: string]: any;
    }, next: () => void): void;
}
export {};
//# sourceMappingURL=Route.d.ts.map